/*******************************************************************************
 *******************************************************************************
 ** Vector initialization routine                                             **
 *******************************************************************************
 *******************************************************************************/


	; KERNAL vectors

iopen	= $031a			; first KERNAL vector
iload	= $0330			; load vector
isave	= $0332			; save vector

	subroutine

zippy_init:
	ifconst OPT_API
	ldx	#.api_end-.api_start
.loop:
	lda	.api_start-1,x
	sta	iopen-1,x
	dex
	bne	.loop
	endif

	lda	#<zload		; get load routine low byte
	ldx	#>zload		; get load routine high byte
	sta	iload		; set load vector low byte
	stx	iload+1		; set load vector high byte
	ifconst OPT_SAVE
	lda	#<zsave		; get save routine low byte
	ldx	#>zsave		; get save routine high byte
	sta	isave		; set save vector low byte
	stx	isave+1		; set save vector high byte
	endif
	ifconst OPT_BANNER
	ldx	#0
.next:
	lda	.banner,x
	beq	.end

	jsr	chrout
	inx
	bne	.next
.end:
	endif

	rts

	; high level KERNAL API routines

	ifconst OPT_API
.api_start:
	dc.w	zopen
	dc.w	zclose
	dc.w	zchkin
	dc.w	zchkout
	dc.w	zclrchn
	dc.w	zchrin
	dc.w	zchrout
	dc.w	$f770		; fstop
	dc.w	zgetin
	dc.w	zclall
.api_end:
	endif

	ifconst	OPT_BANNER
.banner:
	dc.b	"ZIPPY FAST LOADER",13,0
	endif
