	processor	6502

val	= $fd

setlfs  = $ffba
setnam  = $ffbd
open	= $ffc0
close	= $ffc3
chkin	= $ffc6
chkout	= $ffc9
clrchn	= $ffcc
chrin	= $ffcf	
chrout	= $ffd2


	; VICE debug cart I/O address
dbg	= $910f


	org $a000

	subroutine

	jmp	init_and_test
	jmp	do_test
.loop:	jsr	do_test
	beq	.loop
	rts

init_and_test:
	jsr	zippy_init

do_test:
	ifconst	DBG_UART
	jsr	RSINIT
	endif

	; scratch new file
	ldx	#8
	jsr	setlfs
	ldx	#<scratch
	ldy	#>scratch
	lda	#end-scratch
	jsr	setnam
	lda	#0
	sta	status
	ldy	#$6f
	jsr	ser_str

	lda	#'S
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif

	; open file for write
	lda	#6
	ldx	#8
	ldy	#2
	jsr	setlfs
	ldx	#<fname_w
	ldy	#>fname_w
	lda	#scratch-fname_w
	jsr	setnam
	jsr	open
	bcs	.woerr

	; write stuff
	ldx	#6
	jsr	chkout
	bcs	.wkerr

	ldx	#'A
.w1loop:
	txa
	ldy	#20
.w2loop:
	jsr	chrout
	dey
	bne	.w2loop

	lda	#13
	jsr	chrout
	inx
	cpx	#'F
	bne	.w1loop

	jsr	clrchn

	lda	#6
	jsr	close
	bcs	.wcerr

	; open file for read
	lda	#7
	ldx	#8
	ldy	#2
	jsr	setlfs
	ldx	#<fname
	ldy	#>fname
	lda	#end-fname
	jsr	setnam
	jsr	open
	bcs	.roerr

	; read stuff
	ldx	#7
	jsr	chkin
	bcs	.rkerr

	ldy	#0
	sty	val
.rloop:
	iny
	jsr	chrin
	jsr	chrout
	lda	status
	beq	.rloop

	sty	val
	jsr	clrchn

	lda	#7
	jsr	close
	bcs	.rcerr

	lda	val
	cmp	#$69
	bne	.rerr
	
	lda	#0
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#$1d
	sta	$900f
	lda	#0
	rts

.rerr:				; read length error
	lda	#'L
	dc.b	$2c
.roerr:				; read open error
	lda	#'R
	dc.b	$2c
.rkerr:				; input channel error
	lda	#'I
	dc.b	$2c
.rcerr:				; read open error
	lda	#'Q
	dc.b	$2c
.woerr:				; write open error
	lda	#'W
	dc.b	$2c
.wkerr:				; output channel error
	lda	#'O
	dc.b	$2c
.wcerr:				; write close error
	lda	#'C
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#$1a
	sta	$900f
	rts

fname_w:
	dc.b	"API-FILE,S,W"
scratch:
	dc.b	"S0:"
fname:
	dc.b	"API-FILE"
end:

	align	$100

	include "../kernal-defs.asm"
	include "../init.asm"
	include "../core.asm"
	include "../load.asm"
	include "../kernal-api.asm"

	ifconst	DBG_UART
	include "uart.asm"
	endif
