	processor	6502

val	= $ac
ADDR	= $f7
EADDR	= $f9
PTR	= $fb
TMP	= $fd

setlfs  = $ffba
setnam  = $ffbd
load	= $ffd5

	; VICE debug cart I/O address
dbg	= $910f


	org $a000

	subroutine

	jmp	init_and_test
	jmp	do_test
.loop:	jsr	do_test
	beq	.loop
	rts

init_and_test:
	jsr	zippy_init

do_test:
	ifconst	DBG_UART
	jsr	RSINIT
	endif

	ldx	#8
	ldy	#1
	jsr	setlfs
	ldx	#<fname
	ldy	#>fname
	lda	#end-fname
	jsr	setnam
	lda	#'S
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#0
	jsr	load
	bcs	lerr
	lda	#'L
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	txa
	bne	szerr
	cpy	#$80
	bne	szerr
	lda	#$12
	sta	ADDR+1
	lda	#$80
	sta	EADDR+1
	ldx	#val
	jsr	CRC32
	lda	val
	eor	good_crc
	bne	cerr
	lda	val+1
	eor	good_crc+1
	bne	cerr
	lda	val+2
	eor	good_crc+2
	bne	cerr
	lda	val+3
	eor	good_crc+3
	bne	cerr
	lda	#0
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#$1d
	sta	$900f
	lda	#0
	rts

cerr:				; crc error
	lda	#'C
	dc.b	$2c
szerr:				; length error
	lda	#'Z
	dc.b	$2c
lerr:				; load error
	lda	#'E
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#$1a
	sta	$900f
	rts

good_crc:
	dc.l	$ff46badc

fname:
	dc.b	"TEST-FILE"
end:

	include "crc.asm"
	
	align	$100

	include "../kernal-defs.asm"
	include "../init.asm"
	include "../core.asm"
	include "../load.asm"

	ifconst	DBG_UART
	include "uart.asm"
	endif
