	processor	6502

val	= $ac
ADDR	= $f7
EADDR	= $f9
PTR	= $fb
TMP	= $fd

setlfs  = $ffba
setnam  = $ffbd
load	= $ffd5
save	= $ffd8

	; VICE debug cart I/O address
dbg	= $910f


	org $a000

	subroutine

	jmp	init_and_test
	jmp	do_test
.loop:	jsr	do_test
	beq	.loop
	rts

init_and_test:
	jsr	zippy_init

do_test:
	ifconst	DBG_UART
	jsr	RSINIT
	endif

	ldx	#8
	ldy	#1
	jsr	setlfs
	lda	$200
	beq	do_save

	ldx	#<fname
	ldy	#>fname
	lda	#end-fname
	jsr	setnam
	lda	#0
	jsr	load
	bcs	lerr
	lda	#0
	sta	$200

do_save:	
	; scratch new file
	ldx	#8
	jsr	setlfs
	ldx	#<scratch
	ldy	#>scratch
	lda	#fname-scratch
	jsr	setnam
	lda	#0
	sta	status
	ldy	#$6f
	jsr	ser_str

	; save to new file
	ldx	#8
	jsr	setlfs
	ldx	#<fname_out
	ldy	#>fname_out
	lda	#fname-fname_out
	jsr	setnam
	ldx	#0
	ldy	#$80
	stx	ADDR
	lda	#$12
	sta	ADDR+1
	lda	#'B
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#ADDR
	jsr	save
	bcs	serr

	; verify new file
	lda	#'Y
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	ldx	#8
	ldy	#1
	jsr	setlfs
	lda	#1
	jsr	load
	bcs	verr
	lda	status
	and	#%00010000
	bne	verr

	lda	#0
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#$1d
	sta	$900f
	lda	#0
	rts

verr:				; verify error
	lda	#'V
	dc.b	$2c
serr:				; save error
	lda	#'S
	dc.b	$2c
lerr:				; load error
	lda	#'E
	ifconst DBG_VICE
	sta	dbg
	endif
	ifconst DBG_UART
	jsr	RSSEND
	endif
	lda	#$1a
	sta	$900f
	rts

scratch:
	dc.b	"S0:"
fname_out:
	dc.b	"SAVE-FILE"
fname:
	dc.b	"TEST-FILE"
end:

	align	$100

	include "../kernal-defs.asm"
	include "../init.asm"
	include "../core.asm"
	include "../load.asm"
	include "../save.asm"

	ifconst	DBG_UART
	include "uart.asm"
	endif
