import serial
import time

from statistics import mean


if __name__ == '__main__':
    port = '/dev/ttyUSB0'
    vals = []

    try:
        with serial.Serial(port, 9600) as ser:
            rec = []
            while True:
                c = ser.read(1)
                t = time.time()
                print(t, c)

                if rec:
                    if c == b'\x00':
                        if len(rec) == 2:
                            vals.append(rec[1]-rec[0])
                        rec = []
                    else:
                        rec.append(t)
                else:
                    rec.append(t)

    finally:
        print("\n%.4f" % mean(vals),len(vals),"samples\n\n")
